# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, os, sys, time, xbmcvfs
import pztv

if sys.version_info.major > 2:  # Python 3 or later
	import urllib.request
	from urllib.parse import quote
	from urllib.parse import unquote
	import urllib.request as urllib2
	from urllib.parse import urlencode
else:  # Python 2
	import urllib, urlparse
	from urllib import quote
	from urllib import unquote_plus as unquote
	import urllib2
	from urllib import urlencode

def translatePath(s):
	try:
		return xbmcvfs.translatePath(s)
	except:
		return xbmc.translatePath(s)

PLUGIN_NAME   = 'plugin.video.pazl.lt'
#handle = int(sys.argv[1])
addon = xbmcaddon.Addon(id=PLUGIN_NAME)
__settings__ = xbmcaddon.Addon(id=PLUGIN_NAME)
pztv.__settings__=__settings__
icon = translatePath(os.path.join(addon.getAddonInfo('path'), 'icon.png'))
background = translatePath(os.path.join(addon.getAddonInfo('path'), 'fanart.png'))

from lng import *


def log(text, x3=''):
	print (text)

#Action Codes
# See guilib/Key.h
ACTION_CANCEL_DIALOG = (9,10,51,92,110)
ACTION_PLAYFULLSCREEN = (12,79,227)
ACTION_MOVEMENT_LEFT = (1,)
ACTION_MOVEMENT_RIGHT = (2,)
ACTION_MOVEMENT_UP = (3,)
ACTION_MOVEMENT_DOWN = (4,)
ACTION_MOVEMENT = (1, 2, 3, 4, 5, 6, 159, 160)
ACTION_INFO = (11,)
ACTION_CONTEXT = (117,)
ACTION_MOVEMENT_ALL = (1, 2, 3, 4, 5, 6, 159, 160, 104, 105, 106, 107)


#ControlIds
CONTROL_CONSOLES = 500
CONTROL_GENRE = 600
CONTROL_YEAR = 700
CONTROL_PUBLISHER = 800
CONTROL_CHARACTER = 900
FILTER_CONTROLS = (500, 600, 700, 800, 900,)
GAME_LISTS = (50, 51, 52,53, 54, 55, 56, 57, 58)
CONTROL_SCROLLBARS = (2200, 2201, 60, 61, 62)

CONTROL_GAMES_GROUP_START = 600
CONTROL_GAMES_GROUP_END = 59

#CONTROL_BUTTON_CHANGE_VIEW = 2
CONTROL_BUTTON_FAVORITE = 1000
CONTROL_BUTTON_SEARCH = 1100
CONTROL_BUTTON_VIDEOFULLSCREEN = (2900, 2901,)
NON_EXIT_RCB_CONTROLS = (500, 600, 700, 800, 900, 2, 1000, 1100)

CONTROL_LABEL_MSG = 4000
CONTROL_BUTTON_MISSINGINFODIALOG = 4001
STOP=False
UPD=False




def b2s(s):
	if sys.version_info.major > 2:
		try:s=s.decode('utf-8')
		except: pass
		try:s=s.decode('windows-1251')
		except: pass
		try:s=s.decode('cp437')
		except: pass
		return s
	else:
		return s

def eval_u(inf):
	#print (inf)
	if sys.version_info.major > 2: 
		inf2 = 'b'+repr(inf).replace("\\\\x", "\\x")
		#print (inf2)
		info = eval(eval(inf2))##.replace("\\x", "\\\\x").replace("\\r", "\\\\r").replace("\\n", "\\\\n")
		#print (info)
	else:
		info = eval(inf)
	return info


def win2utf(s):
	return s.encode('windows-1251').decode()#.encode('windows-1251').decode('utf-8')

try:
	epg_settings = xbmcaddon.Addon(id='plugin.video.pazl.lt')
	epg_port=epg_settings.getSetting("serv_port")
except:
	epg_port='8085'


def update_list_epg():
	update_current_epg()
	#try: Lepg=eval(pztv.getURL('http://127.0.0.1:'+epg_port+'/channels/all'))
	#except: Lepg=[]

Arhive={}
def update_Arhive():
	global Arhive
	Arhive=pztv.get_arhive_directory()
	#try: Arhive=pztv.get_arhive_directory()
	#except: Arhive={}
#update_Arhive()

last_epg_up = 0
current_epg={}
Lepg=[]
def update_current_epg():
	global current_epg
	global Lepg
	try:
		if time.time()-last_epg_up<30: return
	except: pass

	if __settings__.getSetting("epgon")=='true':
		try:
			for p in range (1, 25):
						xbmc.sleep(10)
						if STOP: break
						current_epg_p=eval(pztv.getURL3('http://127.0.0.1:'+epg_port+'/current/p='+str(p)))
						for k in current_epg_p.keys():
							current_epg[k]=current_epg_p[k]
				
			Lepg=current_epg.keys()
		except:
			#print '!except: current_epg'
			try:
				if current_epg == None: 
					current_epg={}
					Lepg=[]
			except:
				current_epg={}
				Lepg=[]
	else:
			current_epg={}
			Lepg=[]
	last_epg_up = time.time()

#update_list_epg()
#update_current_epg()

def get_type(title):
	if   'Х/ф ' in title: return 'фильмы'
	elif 'Д/ф ' in title: return 'фильмы'
	elif 'Новости' in title: return 'новости'
	elif 'Вести' in title: return 'новости'
	elif 'Т/с ' in title: return 'сериалы'
	elif 'М/с ' in title: return 'детям'
	elif 'М/ф ' in title: return 'детям'
	elif 'Клипы' in title: return 'музыка'
	elif 'Clips' in title: return 'музыка'
	elif 'Playlist' in title: return 'музыка'
	else: return ''

def get_type_art(type):
	film = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'film.jpg'))
	info = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'info.jpg'))
	life = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'life.jpg'))
	mult = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'mult.jpg'))
	news = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'news.jpg'))
	show = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'show.jpg'))
	sport = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'sport.jpg'))
	science = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'science.jpg'))
	music = translatePath(os.path.join(addon.getAddonInfo('path'),'images', 'music.jpg'))
	
	if   type=='фильмы' or type=="movie":  return film
	elif type=='инфо'  or type=="info":    return info
	elif type=='досуг' or type=='live':    return life
	elif type=='детям':                    return mult
	elif type=='новости':                  return news
	elif type=='познавательное':           return science
	elif type=='сериалы' or type=='tvshow': return show
	elif type=='sport'   or type=='спорт' : return sport
	elif type=='музыка'                   : return music
	else: return background

def lower(t):
	RUS={"А":"а", "Б":"б", "В":"в", "Г":"г", "Д":"д", "Е":"е", "Ё":"ё", "Ж":"ж", "З":"з", "И":"и", "Й":"й", "К":"к", "Л":"л", "М":"м", "Н":"н", "О":"о", "П":"п", "Р":"р", "С":"с", "Т":"т", "У":"у", "Ф":"ф", "Х":"х", "Ц":"ц", "Ч":"ч", "Ш":"ш", "Щ":"щ", "Ъ":"ъ", "Ы":"ы", "Ь":"ь", "Э":"э", "Ю":"ю", "Я":"я"}
	for i in range (65,91):
		t=t.replace(chr(i),chr(i+32))
	for i in RUS.keys():
		t=t.replace(i,RUS[i])
	t=t.lower()
	return t

def CRC32(buf):
		import binascii
		if sys.version_info.major > 2: buf = (binascii.crc32(buf.encode('utf-8')) & 0xFFFFFFFF)
		else: buf = (binascii.crc32(buf) & 0xFFFFFFFF)
		r=str("%08X" % buf)
		return r

def get_gid_old(name):
	id = CRC32(lower(name))
	return id

def get_gid(name):
	import GID
	return GID.get_id(name)

class VFS_XML(xbmcgui.WindowXML):
	selectedControlId = 0
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		#xbmcplugin.endOfDirectory(handle, False, False)
		self.uptime=0
		self.info_visible=True
		#self.time_visible=time.time()
		pass

	def onInit(self):
		global UPD
		UPD = True
		#print '-=-=-=-=-=-=- VFS_XML onInit =-=-=-=-=-=-=-'
		self.tugle_info_visible(True)
		#self.setFocus(self.getControl(1))
		v_id    =__settings__.getSetting("v_id")
		last_id =__settings__.getSetting("cplayed")
		#print '-=-=-=-=-=-=- VFS_XML onInit 2=-=-=-=-=-=-=-'
		if xbmc.Player().isPlaying():
			if last_id != v_id: pztv.play(v_id)
		else: 
								pztv.play(v_id)
		#pztv.set_np ()
		__settings__.setSetting("n_play", '0')
		#print '-=-=-=-=-=-=- VFS_XML onInit 3=-=-=-=-=-=-=-'
		#print __settings__.getSetting("v_id")
		self.tugle_info_visible(False)
		
		self.loop()

	def loop(self):
		#pztv.set_np ()
		#print '-=-=-=-=-=-=- VFS_XML loop 1=-=-=-=-=-=-=-'
		try: PlayingFile=xbmc.Player().getPlayingFile()
		except: PlayingFile=''
		#while True:
		if PlayingFile=='':
				self.close()
				'''
				#print '-=-=-=-=-=-=- VFS_XML loop 2=-=-=-=-=-=-=-'
				#try:BanCashe.append(Lpurl2[0])
				#except: pass
				#print __settings__.getSetting("v_id")
				try:n_play=int(__settings__.getSetting("n_play"))
				except:n_play=0
				if n_play<3:
					#print '-=-=-=-=-=-=- VFS_XML loop 3=-=-=-=-=-=-=-'
					__settings__.setSetting("n_play",str(n_play+1))
					#print __settings__.getSetting("v_id")
					#self.tugle_info_visible(True)
					pztv.next (__settings__.getSetting("lastnx"))
					
					#print '-=-=-=-=-=-=- VFS_XML loop 4=-=-=-=-=-=-=-'
					#print __settings__.getSetting("v_id")
					self.tugle_info_visible(True)
					self.loop()
				else:
					self.close()
				'''


	def onInit_old(self):
		#print '-=-=-=-=-=-=- VFS_XML onInit =-=-=-=-=-=-=-'
		self.tugle_info_visible(True)
		self.setFocus(self.getControl(1))
		#self.setEPG()
		v_id =__settings__.getSetting("v_id")
		#if xbmc.Player().isPlaying():
		#	last_id =__settings__.getSetting("cplayed")
		#	if last_id != v_id: pztv.play(v_id)
		#else:
		pztv.play(v_id)
		
		#print '-=-=-=-=-=-=- VFS_XML onInit 2=-=-=-=-=-=-=-'
		#self.setEPG(True)
		#self.tugle_info_visible(True)
		##print '-=-=-=-=-=-=- VFS_XML onInit 2000=-=-=-=-=-=-=-'
		#xbmc.sleep(2000)
		##print '-=-=-=-=-=-=- VFS_XML onInit 2000 ok=-=-=-=-=-=-=-'
		self.tugle_info_visible(False)
		#print '-==- CurrentWindowId =--='
		#print xbmcgui.getCurrentWindowId()
		#self.doModal()
		##print xbmcgui.getCurrentWindowId()
		#print '-=-=-=-=-=-=- VFS_XML onInit info_visible(False)=-=-=-=-=-=-=-'
		#while  xbmc.Player().isPlaying():
		#		xbmc.sleep(500)
		#		self.setEPG()
		#print '-=-=-=-=-=-=- VFS_XML onInit 3=-=-=-=-=-=-=-'
		while  xbmc.Player().isPlaying():
				xbmc.sleep(500)
				#print '-==- CurrentWindowId =--='
				#print xbmcgui.getCurrentWindowId()
				#self.show()
		#print '-=-=-=-=-=-=- VFS_XML onInit 4=-=-=-=-=-=-=-'
		#if not xbmc.Player().isPlaying():
		__settings__.setSetting("lastplayed", '')
		#print '-=-=-=-=-=-=- VFS_XML onInit 5=-=-=-=-=-=-=-'
		self.close()
	
	def onAction(self, action):
		#self.time_visible=time.time()
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		#try:
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
					
				#don't exit RCB here. Just close the filters
				if(self.selectedControlId in NON_EXIT_RCB_CONTROLS):
					#HACK: when list is empty, focus sits on other controls than game list
					if(self.getListSize() > 0):
						self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
						return
					
					log("ListSize == 0 in onAction. Assume that we have to exit.", util.LOG_LEVEL_WARNING)
							
				#if(self.player.isPlayingVideo()):
				#	self.player.stop()
					#xbmc.sleep(util.WAITTIME_PLAYERSTOP)
				if self.selectedControlId in [7,8,9,10,11]: 
					#self.setFocus(self.getControl(1))
					self.tugle_info_visible(False)
				elif self.info_visible==False: 
					self.close()
		
		if action.getId() == 13 :
			xbmc.Player().stop()
			self.close()
		
		if action.getId() == 11 :
			self.tugle_info_visible()
		
		#if action.getId() == 107 : self.setFocus(self.getControl(9))
		if action.getId() in ACTION_CONTEXT: xbmc.executebuiltin('Action("AudioNextLanguage")')
			
		if action.getId() in ACTION_MOVEMENT_UP: self.Next()
			
		if action.getId() in ACTION_MOVEMENT_DOWN: self.Prev()
			
		if action.getId() in ACTION_MOVEMENT_LEFT: 
			if self.info_visible==False: self.run_list()
				
		if action.getId() in ACTION_MOVEMENT_RIGHT: 
			if self.info_visible==False: self.run_list()
		
		self.setEPG()
			
			
	def onClick(self, controlID):
		#print 'onClick ' +str(controlID)
		if controlID == 7: self.run_arhive()
		if controlID == 8: pztv.select_stream()
		if controlID == 11:
			xbmc.Player().stop()
			self.close()
		if controlID == 10 : self.Next()
		if controlID == 9 :  self.Prev()
		if controlID == 1 : 
			self.tugle_info_visible(True)
			#self.setFocus(self.getControl(9))
		if controlID == 6 : 
			self.tugle_info_visible(False)
			#self.setFocus(self.getControl(1))
	
	def onFocus(self, controlID):
		self.selectedControlId = controlID

	def tugle_info_visible(self, vis=' '):
		if vis==True:
			self.uptime=0
			self.setEPG()
		win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
		#self.time_visible=time.time()
		if vis==False:
			self.info_visible=False
			win.setProperty('info_visible',  '')
		elif vis==True:
			self.info_visible=True
			win.setProperty('info_visible',  'true')
		else:
			if self.info_visible==True:
				self.info_visible=False
				win.setProperty('info_visible',  '')
			else: 
				self.info_visible=True
				win.setProperty('info_visible',  'true')
		
		if self.info_visible==False: self.setFocus(self.getControl(1))
		if self.info_visible==True: self.setFocus(self.getControl(9))
	
	def Next(self):
		if xbmc.Player().isPlaying():
			#__settings__.setSetting("n_play","0")
			v_id =__settings__.getSetting("next_itm")
			__settings__.setSetting("v_id", v_id)
			self.tugle_info_visible(True)
			
			v_id=pztv.next ('>')
			#v_id =__settings__.getSetting("cplayed")
			#__settings__.setSetting("v_id", v_id)
			#self.tugle_info_visible(True)
			
			for i in range (5):
				if not xbmc.Player().isPlaying():xbmc.sleep(1000)
				if not xbmc.Player().isPlaying():
					id =__settings__.getSetting("next_itm")
					__settings__.setSetting("v_id", id)
					self.tugle_info_visible(True)
					v_id=pztv.next ('>')
				
			if self.selectedControlId not in [9,10,11]:
				time.sleep(1)
				self.tugle_info_visible(False)

	def Prev(self):
		if xbmc.Player().isPlaying():
			#__settings__.setSetting("n_play","0")
			v_id =__settings__.getSetting("prev_itm")
			__settings__.setSetting("v_id", v_id)
			self.tugle_info_visible(True)
			
			v_id=pztv.next ('<')
			#v_id =__settings__.getSetting("cplayed")
			#__settings__.setSetting("v_id", v_id)
			#self.tugle_info_visible(True)
			
			for i in range (5):
				if not xbmc.Player().isPlaying():xbmc.sleep(1000)
				if not xbmc.Player().isPlaying():
					id =__settings__.getSetting("prev_itm")
					__settings__.setSetting("v_id", id)
					self.tugle_info_visible(True)
					v_id=pztv.next ('<')
			
			if self.selectedControlId not in [9,10,11]:
				time.sleep(1)
				self.tugle_info_visible(False)


	def setEPG(self, up=False):
			try:
				delta=time.time()-self.uptime
				if delta > 45 or up:
					#print '============================ uptime '
					id =__settings__.getSetting("v_id")
					gid  = pztv.DBC[id]['tvg']
					self.uptime=time.time()
					#print '===== set_epg '+id+' ====='
					EPG=[]
					if __settings__.getSetting("epgon")=='true':#gid in Lepg and
							#print '===== set_epg ON'
							lnk='http://127.0.0.1:'+epg_port+'/channels/'+gid
							try:EPG=eval(pztv.getURL3(lnk))
							except:EPG=[]
					
					#EPG=current_epg[gid]
					#print len(EPG)
					if EPG!=[]:
							try:EPG0_time=time.ctime(eval(EPG[0]['time']))[-13:-8]
							except: EPG0_time=''
							try:EPG0_title=EPG[0]['title']
							except: EPG0_title=''
							try:EPG0_img=EPG[0]['img']
							except: EPG0_img=''#background
							try:EPG0_plot=EPG[0]['plot']
							except: EPG0_plot=''
								
							try:EPG1_time=time.ctime(eval(EPG[1]['time']))[-13:-8]
							except: EPG1_time=''
							try:EPG1_title=EPG[1]['title']
							except: EPG1_title=''
							#print '===== set_epg ok1'
					else:
							EPG0_time=''
							EPG0_title=''
							#EPG0_img=pztv.get_picon(id)#background
							EPG0_img=''
							EPG0_plot=''
							EPG1_time=''
							EPG1_title=''
							#print '===== set_epg None'
					
					if EPG0_time!='' and EPG1_time!='':
						t0=eval(EPG[0]['time'])
						t1=eval(EPG[1]['time'])
						tc=time.time()
						total=t1-t0
						back=tc-t0
						percent=int(back*100/total)
						#print '===== set_epg bar ok'
					else:
						percent=0
						#print '===== set_epg bar none'
					
					win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
					
					win.setProperty('EPG1_time',  EPG1_time)
					win.setProperty('EPG1_title', EPG1_title)
					win.setProperty('EPG0_time',  EPG0_time)
					win.setProperty('EPG0_img',   EPG0_img)
					win.setProperty('EPG0_title', EPG0_title)
					win.setProperty('EPG0_plot',  EPG0_plot)
					win.setProperty('picon',   pztv.get_picon(id))
					win.setProperty('title',   pztv.DBC[id]['title'])
					
					bar=self.getControl(5)
					bar.setWidth(percent*5)
					#print '=========== set_epg done =========='
			except:
				#print '=========== set_epg ERRRRRRRRRRRRRRR =========='
				pass



	def run_arhive(self):
				id =__settings__.getSetting("cplayed")
				if id in Arhive.keys(): curl=id#Arhive[id]
				else: curl=""
				if curl!='':
					__settings__.setSetting("arhive_cnl", id)#curl
					__settings__.setSetting("arhive_cnl_id", id)
					arhive = ARHIVE_XML("PTV-arhive.xml", addon.getAddonInfo('path'), skin, "720p")
					xbmc.Player().stop()
					arhive.doModal()
					del arhive
	
	def run_list(self):
				#skin = "Default"
				lst = LIST_XML("PTV-list.xml", addon.getAddonInfo('path'), skin, "720p")
				lst.doModal()
				del lst


class UI_XML(xbmcgui.WindowXML):#Dialog
	selectedControlId = 0
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		# Changing the three varibles passed won't change, anything
		# Doing strXMLname = "bah.xml" will not change anything.
		# don't put GUI sensitive stuff here (as the xml hasn't been read yet
		# Idea to initialize your variables here
		#xbmcplugin.endOfDirectory(handle, False, False)
		self.CurrentListPosition=0
		self.uptime=0
		self.uparh=0
		self.clp=0
		if __settings__.getSetting("arhon")=='true': update_Arhive()
		pass

	def onInit(self):
		
		global UPD
		try:
			# Put your List Populating code/ and GUI startup stuff here
			self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
			#self.clearList()
			
			self.showList()
			
			abc=__settings__.getSetting("abc")
			btn=self.getControl(1)
			if abc == 'false':	btn.setLabel(lcl('Порядок: Свой'))
			else:				btn.setLabel(lcl('Порядок: ABC'))
			btn2=self.getControl(5)
			btn2.setLabel(lcl('Настройки'))
			#if __settings__.getSetting("cllogo")=='true':
			#	__settings__.setSetting("cllogo",'false')
			#	pztv.cllogo()
			#if __settings__.getSetting("arhon")=='true' and self.uparh==0:
			#	update_Arhive()
			#	self.uparh=1
			#	self.setArhive()
			if UPD==False:
				pztv.update_DBC()
				#pztv.billing()
				UPD=True
		except:
			pass


	def onAction(self, action):
		global STOP
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
				STOP=True
				self.exit()
		
		elif (action.getId() in ACTION_CONTEXT):
				self.showContextMenu()
		
		if action.getId() in ACTION_MOVEMENT_ALL:
			self.CurrentListPosition=self.getCurrentListPosition()
			if self.selectedControlId == 600:
				self.setINFO()
				
				try:uptime=eval(__settings__.getSetting("uptime"))
				except: uptime=0
				delta=time.time()-self.uptime
				if delta > 55: 
					__settings__.setSetting("uptime", repr(time.time()))
					self.updateEPG()
					
		if(action.getId() == 13):# stop
			#self.showList()
			Player.play(playlist, startpos=999999)# stop
			self.setPlayed()
		if(action.getId() == 11):# info
			if self.selectedControlId == 600:
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				curl = listitem.getProperty('arhive')
				id   = listitem.getProperty('id')
				if curl!='': 
					__settings__.setSetting("arhive_cnl", curl)
					__settings__.setSetting("arhive_cnl_id", id)
					self.run_arhive()#xbmc.executebuiltin('ActivateWindow(10025,"'+curl+'", return)')


	def onClick(self, controlID):
		#print 'onClick ' +str(controlID)
		if controlID == 600:
			#n = self.getCurrentListPosition()
			#listitem = self.getListItem(n)
			id = self.get_cnl_id() #id = listitem.getProperty('id')
			if id=='': self.exit()
			else: 
				__settings__.setSetting("v_id", id)
				#if __settings__.getSetting("xplay")=='false':
				pztv.play(id)
				'''
				else:
					if xbmc.Player().isPlaying():
						#last_id =__settings__.getSetting("cplayed")
						#if last_id != id: 
						xbmc.Player().stop()
					#skin = "Default"
					if __settings__.getSetting("screen")=='0':  FullScreen = "PTV-VideoFullScreen.xml"
					elif __settings__.getSetting("screen")=='1':  FullScreen = "PTV-VideoFullScreen1.xml"
					else: 										FullScreen = "PTV-VideoFullScreen2.xml"
					vfs = VFS_XML(FullScreen, addon.getAddonInfo('path'), skin, "720p")
					vfs.doModal()
					del vfs
				'''
				#self.showList()
				self.setPlayed()
				
		if controlID == 800:
			list=self.getControl(controlID)
			self.clp=list.getSelectedPosition()
			listitem=list.getSelectedItem()
			SG=listitem.getLabel()
			if 'COLOR' in SG: SG=pztv.get_access_gr(SG)
			if 'COLOR' not in SG:__settings__.setSetting("Sel_gr",SG)
			self.CurrentListPosition=0
			self.showList()
			#list.selectItem(clp)
		if controlID == 5:
			__settings__.openSettings()
			self.showList()
		if controlID == 1:
			abc=__settings__.getSetting("abc")
			btn=self.getControl(controlID)
			if abc == 'true':
				__settings__.setSetting("abc", 'false')
				btn.setLabel('Порядок: Свой')
			else:
				__settings__.setSetting("abc", 'true')
				btn.setLabel('Порядок: ABC')
			self.showList()

	def onFocus(self, controlID):
		self.setINFO()
		self.selectedControlId = controlID
		
		if controlID == 6: 
			list=self.getControl(800)
			self.setFocusId(800)
			list.selectItem(list.size()-1)
			
		pass

	def exit(self):
		if pztv.get_autoexit_gr(): __settings__.setSetting("Sel_gr", 'Все каналы')
		log("PTV exit")
		self.close()
	
	def get_cnl_id(self):
			list1=self.getControl(600)
			#n = self.getCurrentListPosition()
			listitem = list1.getSelectedItem()#list1.getListItem(n)
			id = listitem.getProperty('id')
			return id
	
	def getCurrentListPosition(self):
		list1=self.getControl(600)
		n=list1.getSelectedPosition()
		return n
	
	def setCurrentListPosition(self, n):
		list1=self.getControl(600)
		list1.selectItem(n)
	
	def set_cnl_epg(self, cid1):
		D2=eval(pztv.getURL('http://127.0.0.1:'+epg_port+'/channels/dict'))
		D2['- НЕ СВЯЗАН']='000000'
		L=D2.keys()
		L.sort()
		sel = xbmcgui.Dialog()
		r = sel.select("Выберите программу передач:", L)
		if r>-1:
			nm=L[r]
			cid2=D2[nm]
			##print cid2+' to '+cid1
			pztv.getURL('http://127.0.0.1:'+epg_port+'/change/id='+cid1+'/to='+cid2)
		update_list_epg()
		self.updateEPG()

	def showContextMenu(self):
		clp=self.getCurrentListPosition()
		controlID=self.selectedControlId
		#print 'showContextMenu '+ str(controlID)
		if controlID == 600:
			id = self.get_cnl_id()
			if __settings__.getSetting("abc")=='true': 
				  context=[lcl('Добавить в группу'),lcl('Удалить из группы'),lcl('Объеденить с каналом'), lcl('Разделить канал'),lcl('Переименовать канал'), lcl('Удалить канал'), lcl('Установить EPG'), lcl('Установить логотип')]
			else: context=[lcl('Добавить в группу'),lcl('Удалить из группы'),lcl('Переместить в группе'),lcl('Объеденить с каналом'), lcl('Разделить канал'),lcl('Переименовать канал'), lcl('Удалить канал'), lcl('Установить EPG'), lcl('Установить логотип')]
			if id in Arhive.keys(): context.append(lcl('Архив'))
			
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				if   func==lcl('Добавить в группу'):    pztv.add_to_gr(id)
				elif func==lcl('Удалить из группы'):    pztv.rem_from_gr(id)
				elif func==lcl('Переместить в группе'): pztv.set_num_cn(id)
				elif func==lcl('Объеденить с каналом'): pztv.append_cnl(id)
				elif func==lcl('Разделить канал'):      pztv.split_cnl(id)
				elif func==lcl('Переименовать канал'):  pztv.rename_cnl(id)
				elif func==lcl('Удалить канал'):        pztv.remove_cnl(id)
				elif func==lcl('Установить EPG'):       self.set_cnl_epg(id)
				elif func==lcl('Установить логотип'):   self.context_picon()
				elif func==lcl('Архив'):                self.context_arhive()
				
				if   func!=lcl('Добавить в группу'): self.showList()
		if controlID == 800:
			context1=[lcl('Создать группу'),lcl('Удалить группу'),lcl('Переместить группу'),lcl('Переименовать группу'), lcl('Объединить с группой'),lcl('Установить пароль'),lcl('Редактор каналов'),lcl('Обновить каналы'),lcl('Обновить телепрограмму'), lcl('Найти канал')]
			context2=[lcl('Создать группу'),lcl('Переместить группу'),lcl('Снять пароль'),lcl('Редактор каналов'),lcl('Обновить каналы'),lcl('Обновить телепрограмму')]
			list2=self.getControl(800)
			listitem=list2.getSelectedItem()
			label=listitem.getLabel()
			if 'COLOR' in label:
				label=label.replace('[COLOR 44FFFFFF]','').replace('[/COLOR]','')
				context=context2
			else:
				context=context1
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				
				if   func==lcl('Создать группу'):       pztv.add_gr()
				elif func==lcl('Удалить группу'):       pztv.rem_gr(label)
				elif func==lcl('Переместить группу'):   pztv.move_gr(label)
				elif func==lcl('Переименовать группу'): pztv.rename_gr(label)
				elif func==lcl('Объединить с группой'): pztv.extend_gr(label)
				elif func==lcl('Установить пароль'):    pztv.set_pass_gr(label)
				elif func==lcl('Снять пароль'):         pztv.rem_pass_gr(label)
				elif func==lcl('Редактор каналов'):     self.run_editor()
				elif func==lcl('Обновить каналы'):      pztv.update_cnl()
				elif func==lcl('Найти канал'):          pztv.get_outbase()
				elif func==lcl('Обновить телепрограмму'): pztv.getURL('http://127.0.0.1:'+epg_port+'/update')

				if label == __settings__.getSetting("Sel_gr"): __settings__.setSetting("Sel_gr", 'Все каналы')
				self.showList()
		self.setCurrentListPosition(clp)

	def context_arhive(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				id = listitem.getProperty('id')
				curl = listitem.getProperty('arhive')
				if curl!='': 
					__settings__.setSetting("arhive_cnl", curl)
					__settings__.setSetting("arhive_cnl_id", id)
					self.run_arhive()

	def context_picon(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				title = listitem.getLabel() 
				id = listitem.getProperty('id')
				__settings__.setSetting("picon_cnl", title)
				__settings__.setSetting("picon_id", id)
				self.run_picon()


	def setINFO(self):
			list1=self.getControl(600)
			item=list1.getSelectedItem()
			win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
			try:
					win.setProperty('EPG2_time',  item.getProperty('EPG2_time'))
					win.setProperty('EPG2_title', item.getProperty('EPG2_title'))
					win.setProperty('EPG1_time',  item.getProperty('EPG1_time'))
					win.setProperty('EPG1_title', item.getProperty('EPG1_title'))
					win.setProperty('EPG0_title', item.getProperty('EPG0_title'))
					win.setProperty('EPG0_time',  item.getProperty('EPG0_time'))
					if xbmc.Player().isPlaying(): win.setProperty('EPG0_img', '')
					else:                         win.setProperty('EPG0_img',   item.getProperty('EPG0_img'))
					win.setProperty('EPG0_plot',  item.getProperty('EPG0_plot'))
					
					if item.getProperty('EPG0_time')!='': win.setProperty('EPG_pr', 'rcb-ScrollBarH_bar.png')
					else:                                 win.setProperty('EPG_pr', 'false')
					for i in range(0,11):
						if item.getProperty('EPG_pr'+str(i*10)) == 'true': win.setProperty('EPG_pr'+str(i*10), 'rcb-ScrollBarH_bar_focus.png')
						else:                                              win.setProperty('EPG_pr'+str(i*10), 'false')
						#win.setProperty('EPG_pr'+str(i*10), 'true')
			except:
				print ('=========== set_info ERRRRRRRRRRRRRRR ==========')

	def set_epg(self, item):
		self.uptime=time.time()
		gid=item.getProperty('gid')
		id=item.getProperty('id')
		EPG={}
		try:
			if id in current_epg.keys(): EPG=current_epg[id]
			elif gid in current_epg.keys(): EPG=current_epg[gid]
		except: 
			print ('err current_epg '+id)
		
		if EPG!={}:
					try:EPG0_time=time.ctime(eval(EPG[0]['time']))[-13:-8]
					except: EPG0_time=''
					try:EPG0_title=EPG[0]['title']
					except: EPG0_title=''
					try:EPG0_img=EPG[0]['img']
					except: EPG0_img=background
					if EPG0_img=='':EPG0_img=background
					try:EPG0_plot=EPG[0]['plot']
					except: EPG0_plot=''
					try:EPG0_type=EPG[0]['type']
					except: EPG0_type=''
					
					try:EPG1_time=time.ctime(eval(EPG[1]['time']))[-13:-8]
					except: EPG1_time=''
					try:EPG1_title=EPG[1]['title']
					except: EPG1_title=''
					
					try:EPG2_time=time.ctime(eval(EPG[2]['time']))[-13:-8]
					except: EPG2_time=''
					try:EPG2_title=EPG[2]['title']
					except: EPG2_title=''
					
		else:
					EPG0_time=''
					EPG0_title=''
					EPG0_img=background
					EPG0_plot=''
					EPG0_type=''
					EPG1_time=''
					EPG1_title=''
					EPG2_time=''
					EPG2_title=''
		
		if EPG0_time!='' and EPG1_time!='':
				t0=eval(EPG[0]['time'])
				t1=eval(EPG[1]['time'])
				tc=time.time()
				total=t1-t0
				back=tc-t0
				percent=int(back*100/total)
				for i in range(0,11):
					if i*10 <= percent < i*10+10 :  item.setProperty('EPG_pr'+str(i*10), 'true')
					else:				item.setProperty('EPG_pr'+str(i*10), 'false')
		
		EPG0_img=background
		if __settings__.getSetting("typeart")=='true': 
			if EPG0_type=='':EPG0_type=get_type(EPG0_title)
			if EPG0_type!='' and EPG0_img==background: EPG0_img=get_type_art(EPG0_type)
			if EPG0_img==background: EPG0_img=''#item.getProperty('picon')
		item.setProperty('EPG0_time',  EPG0_time)
		item.setProperty('EPG0_title', EPG0_title)
		item.setProperty('EPG0_img',   EPG0_img)
		item.setProperty('EPG0_plot',  EPG0_plot)#EPG0_type+"\n"+
		
		item.setProperty('EPG1_time',  EPG1_time)
		item.setProperty('EPG1_title', EPG1_title)
		item.setProperty('EPG2_time',  EPG2_time)
		item.setProperty('EPG2_title', EPG2_title)
		self.setINFO()
		#return item
		
	def showList(self):
		passw = str(__settings__.getSetting("passw"))
		playlist = xbmc.PlayList (xbmc.PLAYLIST_VIDEO)
		playlist.clear()
		#Каналы
		#print '== showList start'
		#L=pztv.root(__settings__.getSetting("Sel_gr"))
		try:L=pztv.root(__settings__.getSetting("Sel_gr"))
		except: L=[]
		#print (L)
		#print '== showList 1'
		list1=self.getControl(600)
		self.CurrentListPosition =  self.getCurrentListPosition()
		#list1.reset()
		if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
		else: last_id ='0'
		n=0
		#pos_set=True
		
		picon_background = translatePath(os.path.join(addon.getAddonInfo('path'), 'background.png'))
		Litm=[]
		#if L==[]:L=[{'title':'', 'id':'0', 'tvg':'0', 'picon':''}]
		intlogo=__settings__.getSetting("intlogo")
		AK=Arhive.keys()
		#print '== showList 4'
		for i in L:
				title=i['title']
				id = i['id']
				gid= i['tvg']#get_gid(title)
				item = xbmcgui.ListItem(title)
				item.setProperty('background', background)
				item.setProperty('id', id)
				item.setProperty('gid', gid)
				#if id in AK and __settings__.getSetting("arhon")=='true': 
				#	item.setProperty('arhive', id)
				#	item.setProperty('arhive_visible', 'true')
				#else:
				item.setProperty('arhive_visible', 'false')
				if intlogo == 'true':
					item.setProperty('picon', i['picon'])
					item.setProperty('picon_background', picon_background)
				Litm.append(item)
				#list1.addItem(item)
				
				#if last_id == id:
				#	self.CurrentListPosition=n
					#self.setCurrentListPosition(self.CurrentListPosition)
					#self.setPlayed()
				n+=1
				
				pl_url='http://'+passw+'.tdwvt.keenetic.pro/stream/'+i['id']#+pztv.UA
				pl_url = 'http://127.0.0.1:18189/restream/'+pl_url
				pl_item = xbmcgui.ListItem(title, path=pl_url)
				pl_item.setArt({'thumb':i['picon'], 'icon':i['picon']})
				pl_item.setMimeType('video/mpeg')
				pl_item.setContentLookup(False)
				playlist.add(url=pl_url, listitem=pl_item)
		
		pl_item = xbmcgui.ListItem('   ', path='http://roms.my1.ru/tv/term.mp4')
		playlist.add(url='http://roms.my1.ru/tv/term.mp4', listitem=pl_item)
		list1.reset()
		list1.addItems(Litm)
		
		#print '== showList 5'
		self.setCurrentListPosition(self.CurrentListPosition)
		self.setPlayed()
		#if __settings__.getSetting("arhon")=='true': self.setArhive()
		xbmc.sleep(10)
		#Группы
		self.getControl(95).setLabel(lcl('Группа: ')+lcl(__settings__.getSetting("Sel_gr")))
		list2=self.getControl(800)
		list2.reset()
		Lgr=pztv.select_gr('', True)
		n=0
		for i in Lgr:
				item = xbmcgui.ListItem(lcl(str(i)))
				list2.addItem(item)
		list2.selectItem(self.clp)
		
		
		#if len(L)>0: self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
		#else:self.setFocus(self.getControl(800))
		if len(L)>0:     self.setFocus(self.getControl(600))
		elif len(Lgr)>0: self.setFocus(self.getControl(800))
		else:            self.setFocus(self.getControl(5))
		
		xbmc.sleep(10)
		#print '== showList 6'
		if len(L)>0: self.updateEPG()
		#print '== showList end'
	
	def setPlayed(self):
			if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
			else: last_id ='0'
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					if last_id == item.getProperty('id'): item.setLabel2(item.getLabel())
					else: item.setLabel2('')
				except:
					pass
	
	def setArhive2(self):
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(0, n):
				item = list1.getListItem(i)
				id = item.getProperty('id')
				if id in Arhive.keys(): 
					arh=id
				#	arh=Arhive[id]
				else:
					arh=""
				item.setProperty('arhive', arh)
				if arh == '': item.setProperty('arhive_visible', 'false')
				else:        item.setProperty('arhive_visible', 'true')

	def setArhive(self):
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			AK=Arhive.keys()
			
			for i in range(n):
				item = list1.getListItem(i)
				id = item.getProperty('id')
				if id in AK: 
					item.setProperty('arhive', id)
					item.setProperty('arhive_visible', 'true')


	def updateEPG(self):
		list1=self.getControl(600)
		if __settings__.getSetting("epgon")=='true' and list1.size()>0:
			for i in range(0, list1.size()):
				try:
					item = list1.getListItem(i)
					self.set_epg(item)
				except: pass
			
			update_current_epg()
			
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					self.set_epg(item)
				except: 
					#self.close()
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
		else:
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					#item.setProperty('EPG0_title', item.getLabel())
					item.setProperty('EPG0_img',background)#item.getProperty('picon')
				except: 
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
	
	def run_editor(self):
				#skin = "Default"
				editor = EDITOR_XML("PTV-EDITOR.xml", addon.getAddonInfo('path'), skin, "720p")
				editor.doModal()
				del editor

	def run_arhive(self):
				#skin = "Default"
				arhive = ARHIVE_XML("PTV-arhive.xml", addon.getAddonInfo('path'), skin, "720p")
				arhive.doModal()
				del arhive
	def run_picon(self):
				#skin = "Default"
				picon = PICON_XML("PTV-picon.xml", addon.getAddonInfo('path'), skin, "720p")
				picon.doModal()
				del picon



class LIST_XML(xbmcgui.WindowXMLDialog):#Dialog
	selectedControlId = 0
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		# Changing the three varibles passed won't change, anything
		# Doing strXMLname = "bah.xml" will not change anything.
		# don't put GUI sensitive stuff here (as the xml hasn't been read yet
		# Idea to initialize your variables here
		#xbmcplugin.endOfDirectory(handle, False, False)
		self.CurrentListPosition=0
		self.uptime=0
		self.uparh=0
		self.clp=0
		if __settings__.getSetting("arhon")=='true': update_Arhive()
		pass

	def onInit(self):
		#global UPD
		try:
			# Put your List Populating code/ and GUI startup stuff here
			self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
			#self.clearList()
			
			self.showList()
			
			abc=__settings__.getSetting("abc")
			btn=self.getControl(1)
			if abc == 'false':	btn.setLabel(lcl('Порядок: Свой'))
			else:				btn.setLabel(lcl('Порядок: ABC'))
			btn2=self.getControl(5)
			btn2.setLabel(lcl('Настройки'))
			#if __settings__.getSetting("cllogo")=='true':
			#	__settings__.setSetting("cllogo",'false')
			#	pztv.cllogo()
			#if __settings__.getSetting("arhon")=='true' and self.uparh==0:
			#	update_Arhive()
			#	self.uparh=1
			#	self.setArhive()
			#if UPD==False:
			#	pztv.update_DBC()
			#	UPD=True
		except:
			pass


	def onAction(self, action):
		#global STOP
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
				#STOP=True
				self.exit()
		
		elif (action.getId() in ACTION_CONTEXT):
				self.showContextMenu()
		
		if action.getId() in ACTION_MOVEMENT_ALL:
			self.CurrentListPosition=self.getCurrentListPosition()
			if self.selectedControlId == 600:
				self.setINFO()
				
				try:uptime=eval(__settings__.getSetting("uptime"))
				except: uptime=0
				delta=time.time()-self.uptime
				if delta > 55: 
					__settings__.setSetting("uptime", repr(time.time()))
					self.updateEPG()
					
		if(action.getId() == 13):# stop
			#self.showList()
			self.setPlayed()
		if(action.getId() == 11):# info
			if self.selectedControlId == 600:
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				curl = listitem.getProperty('arhive')
				id   = listitem.getProperty('id')
				if curl!='': 
					__settings__.setSetting("arhive_cnl", curl)
					__settings__.setSetting("arhive_cnl_id", id)
					self.run_arhive()#xbmc.executebuiltin('ActivateWindow(10025,"'+curl+'", return)')


	def onClick(self, controlID):
		#print 'onClick ' +str(controlID)
		if controlID == 600:
				id = self.get_cnl_id()
				if id=='': self.exit()
				else: 
					__settings__.setSetting("v_id", id)
					xbmc.Player().stop()
					xbmc.sleep(100)
					pztv.play(id)
					self.exit()
				
		if controlID == 800:
			list=self.getControl(controlID)
			self.clp=list.getSelectedPosition()
			listitem=list.getSelectedItem()
			SG=listitem.getLabel()
			if 'COLOR' in SG: SG=pztv.get_access_gr(SG)
			if 'COLOR' not in SG:__settings__.setSetting("Sel_gr",SG)
			self.CurrentListPosition=0
			self.showList()
			#list.selectItem(clp)
		if controlID == 5:
			__settings__.openSettings()
			self.showList()
		if controlID == 1:
			abc=__settings__.getSetting("abc")
			btn=self.getControl(controlID)
			if abc == 'true':
				__settings__.setSetting("abc", 'false')
				btn.setLabel('Порядок: Свой')
			else:
				__settings__.setSetting("abc", 'true')
				btn.setLabel('Порядок: ABC')
			self.showList()

	def onFocus(self, controlID):
		self.setINFO()
		self.selectedControlId = controlID
		
		if controlID == 6: 
			list=self.getControl(800)
			self.setFocusId(800)
			list.selectItem(list.size()-1)
		
		if controlID == 61:
			self.exit()

			
		pass

	def exit(self):
		if pztv.get_autoexit_gr(): __settings__.setSetting("Sel_gr", 'Все каналы')
		log("PTV exit")
		self.close()
	
	def get_cnl_id(self):
			list1=self.getControl(600)
			#n = self.getCurrentListPosition()
			listitem = list1.getSelectedItem()#list1.getListItem(n)
			id = listitem.getProperty('id')
			return id
	
	def getCurrentListPosition(self):
		list1=self.getControl(600)
		n=list1.getSelectedPosition()
		return n
	
	def setCurrentListPosition(self, n):
		list1=self.getControl(600)
		list1.selectItem(n)
	
	def set_cnl_epg(self, cid1):
		D2=eval(pztv.getURL('http://127.0.0.1:'+epg_port+'/channels/dict'))
		D2['- НЕ СВЯЗАН']='000000'
		L=D2.keys()
		L.sort()
		sel = xbmcgui.Dialog()
		r = sel.select("Выберите программу передач:", L)
		if r>-1:
			nm=L[r]
			cid2=D2[nm]
			##print cid2+' to '+cid1
			pztv.getURL('http://127.0.0.1:'+epg_port+'/change/id='+cid1+'/to='+cid2)
		update_list_epg()
		self.updateEPG()

	def showContextMenu(self):
		clp=self.getCurrentListPosition()
		controlID=self.selectedControlId
		#print 'showContextMenu '+ str(controlID)
		if controlID == 600:
			id = self.get_cnl_id()
			if __settings__.getSetting("abc")=='true': 
				  context=[lcl('Добавить в группу'),lcl('Удалить из группы'),lcl('Объеденить с каналом'), lcl('Разделить канал'),lcl('Переименовать канал'), lcl('Удалить канал'), lcl('Установить EPG'), lcl('Установить логотип')]
			else: context=[lcl('Добавить в группу'),lcl('Удалить из группы'),lcl('Переместить в группе'),lcl('Объеденить с каналом'), lcl('Разделить канал'),lcl('Переименовать канал'), lcl('Удалить канал'), lcl('Установить EPG'), lcl('Установить логотип')]
			if id in Arhive.keys(): context.append(lcl('Архив'))
			
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				if   func==lcl('Добавить в группу'):    pztv.add_to_gr(id)
				elif func==lcl('Удалить из группы'):    pztv.rem_from_gr(id)
				elif func==lcl('Переместить в группе'): pztv.set_num_cn(id)
				elif func==lcl('Объеденить с каналом'): pztv.append_cnl(id)
				elif func==lcl('Разделить канал'):      pztv.split_cnl(id)
				elif func==lcl('Переименовать канал'):  pztv.rename_cnl(id)
				elif func==lcl('Удалить канал'):        pztv.remove_cnl(id)
				elif func==lcl('Установить EPG'):       self.set_cnl_epg(id)
				elif func==lcl('Установить логотип'):   self.context_picon()
				elif func==lcl('Архив'):                self.context_arhive()
				
				if   func!=lcl('Добавить в группу'): self.showList()
		if controlID == 800:
			context1=[lcl('Создать группу'),lcl('Удалить группу'),lcl('Переместить группу'),lcl('Переименовать группу'), lcl('Объединить с группой'),lcl('Установить пароль'),lcl('Редактор каналов'),lcl('Обновить каналы'),lcl('Обновить телепрограмму'), lcl('Найти канал')]
			context2=[lcl('Создать группу'),lcl('Переместить группу'),lcl('Снять пароль'),lcl('Редактор каналов'),lcl('Обновить каналы'),lcl('Обновить телепрограмму')]
			list2=self.getControl(800)
			listitem=list2.getSelectedItem()
			label=listitem.getLabel()
			if 'COLOR' in label:
				label=label.replace('[COLOR 44FFFFFF]','').replace('[/COLOR]','')
				context=context2
			else:
				context=context1
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				
				if   func==lcl('Создать группу'):       pztv.add_gr()
				elif func==lcl('Удалить группу'):       pztv.rem_gr(label)
				elif func==lcl('Переместить группу'):   pztv.move_gr(label)
				elif func==lcl('Переименовать группу'): pztv.rename_gr(label)
				elif func==lcl('Объединить с группой'): pztv.extend_gr(label)
				elif func==lcl('Установить пароль'):    pztv.set_pass_gr(label)
				elif func==lcl('Снять пароль'):         pztv.rem_pass_gr(label)
				elif func==lcl('Редактор каналов'):     self.run_editor()
				elif func==lcl('Обновить каналы'):      pztv.update_cnl()
				elif func==lcl('Найти канал'):          pztv.get_outbase()
				elif func==lcl('Обновить телепрограмму'): pztv.getURL('http://127.0.0.1:'+epg_port+'/update')

				if label == __settings__.getSetting("Sel_gr"): __settings__.setSetting("Sel_gr", 'Все каналы')
				self.showList()
		self.setCurrentListPosition(clp)

	def context_arhive(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				id = listitem.getProperty('id')
				curl = listitem.getProperty('arhive')
				if curl!='': 
					__settings__.setSetting("arhive_cnl", curl)
					__settings__.setSetting("arhive_cnl_id", id)
					self.run_arhive()

	def context_picon(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				title = listitem.getLabel() 
				id = listitem.getProperty('id')
				__settings__.setSetting("picon_cnl", title)
				__settings__.setSetting("picon_id", id)
				self.run_picon()


	def setINFO(self):
			list1=self.getControl(600)
			item=list1.getSelectedItem()
			win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
			try:
					win.setProperty('EPG2_time',  item.getProperty('EPG2_time'))
					win.setProperty('EPG2_title', item.getProperty('EPG2_title'))
					win.setProperty('EPG1_time',  item.getProperty('EPG1_time'))
					win.setProperty('EPG1_title', item.getProperty('EPG1_title'))
					win.setProperty('EPG0_title', item.getProperty('EPG0_title'))
					win.setProperty('EPG0_time',  item.getProperty('EPG0_time'))
					if xbmc.Player().isPlaying(): win.setProperty('EPG0_img', '')
					else:                         win.setProperty('EPG0_img',   item.getProperty('EPG0_img'))
					win.setProperty('EPG0_plot',  item.getProperty('EPG0_plot'))
					
					if item.getProperty('EPG0_time')!='': win.setProperty('EPG_pr', 'rcb-ScrollBarH_bar.png')
					else:                                 win.setProperty('EPG_pr', 'false')
					for i in range(0,11):
						if item.getProperty('EPG_pr'+str(i*10)) == 'true': win.setProperty('EPG_pr'+str(i*10), 'rcb-ScrollBarH_bar_focus.png')
						else:                                              win.setProperty('EPG_pr'+str(i*10), 'false')
						#win.setProperty('EPG_pr'+str(i*10), 'true')
			except:
				print ('=========== set_info ERRRRRRRRRRRRRRR ==========')

	def set_epg(self, item):
		self.uptime=time.time()
		gid=item.getProperty('gid')
		id=item.getProperty('id')
		EPG={}
		try:
			if id in current_epg.keys(): EPG=current_epg[id]
			elif gid in current_epg.keys(): EPG=current_epg[gid]
		except: 
			print ('err current_epg '+id)
		
		if EPG!={}:
					try:EPG0_time=time.ctime(eval(EPG[0]['time']))[-13:-8]
					except: EPG0_time=''
					try:EPG0_title=EPG[0]['title']
					except: EPG0_title=''
					try:EPG0_img=EPG[0]['img']
					except: EPG0_img=background
					if EPG0_img=='':EPG0_img=background
					try:EPG0_plot=EPG[0]['plot']
					except: EPG0_plot=''
					try:EPG0_type=EPG[0]['type']
					except: EPG0_type=''
					
					try:EPG1_time=time.ctime(eval(EPG[1]['time']))[-13:-8]
					except: EPG1_time=''
					try:EPG1_title=EPG[1]['title']
					except: EPG1_title=''
					
					try:EPG2_time=time.ctime(eval(EPG[2]['time']))[-13:-8]
					except: EPG2_time=''
					try:EPG2_title=EPG[2]['title']
					except: EPG2_title=''
					
		else:
					EPG0_time=''
					EPG0_title=''
					EPG0_img=background
					EPG0_plot=''
					EPG0_type=''
					EPG1_time=''
					EPG1_title=''
					EPG2_time=''
					EPG2_title=''
		
		if EPG0_time!='' and EPG1_time!='':
				t0=eval(EPG[0]['time'])
				t1=eval(EPG[1]['time'])
				tc=time.time()
				total=t1-t0
				back=tc-t0
				percent=int(back*100/total)
				for i in range(0,11):
					if i*10 <= percent < i*10+10 :  item.setProperty('EPG_pr'+str(i*10), 'true')
					else:				item.setProperty('EPG_pr'+str(i*10), 'false')
		
		EPG0_img=background
		if __settings__.getSetting("typeart")=='true': 
			if EPG0_type=='':EPG0_type=get_type(EPG0_title)
			if EPG0_type!='' and EPG0_img==background: EPG0_img=get_type_art(EPG0_type)
			if EPG0_img==background: EPG0_img=''#item.getProperty('picon')
		item.setProperty('EPG0_time',  EPG0_time)
		item.setProperty('EPG0_title', EPG0_title)
		item.setProperty('EPG0_img',   EPG0_img)
		item.setProperty('EPG0_plot',  EPG0_plot)#EPG0_type+"\n"+
		
		item.setProperty('EPG1_time',  EPG1_time)
		item.setProperty('EPG1_title', EPG1_title)
		item.setProperty('EPG2_time',  EPG2_time)
		item.setProperty('EPG2_title', EPG2_title)
		self.setINFO()
		#return item
		
	def showList(self):
		
		#Каналы
		#print '== showList start'
		#L=pztv.root(__settings__.getSetting("Sel_gr"))
		try:L=pztv.root(__settings__.getSetting("Sel_gr"))
		except: L=[]
		#print (L)
		#print '== showList 1'
		list1=self.getControl(600)
		self.CurrentListPosition =  self.getCurrentListPosition()
		#list1.reset()
		if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
		else: last_id ='0'
		n=0
		#pos_set=True
		
		picon_background = translatePath(os.path.join(addon.getAddonInfo('path'), 'background.png'))
		Litm=[]
		#if L==[]:L=[{'title':'', 'id':'0', 'tvg':'0', 'picon':''}]
		intlogo=__settings__.getSetting("intlogo")
		AK=Arhive.keys()
		#print '== showList 4'
		for i in L:
				title=i['title']
				id = i['id']
				gid=i['tvg']
				item = xbmcgui.ListItem(title)
				#item.setProperty('background', background)
				item.setProperty('id', id)
				item.setProperty('gid', gid)
				#if id in AK and __settings__.getSetting("arhon")=='true': 
				#	item.setProperty('arhive', id)
				#	item.setProperty('arhive_visible', 'true')
				#else:
				item.setProperty('arhive_visible', 'false')
				if intlogo == 'true':
					item.setProperty('picon', i['picon'])
					item.setProperty('picon_background', picon_background)
				Litm.append(item)
				#list1.addItem(item)
				
				#if last_id == id:
				#	self.CurrentListPosition=n
					#self.setCurrentListPosition(self.CurrentListPosition)
					#self.setPlayed()
				n+=1
		list1.reset()
		list1.addItems(Litm)
		
		#print '== showList 5'
		self.setCurrentListPosition(self.CurrentListPosition)
		self.setPlayed()
		#if __settings__.getSetting("arhon")=='true': self.setArhive()
		xbmc.sleep(10)
		#Группы
		self.getControl(95).setLabel(lcl('Группа: ')+lcl(__settings__.getSetting("Sel_gr")))
		list2=self.getControl(800)
		list2.reset()
		Lgr=pztv.select_gr('', True)
		n=0
		for i in Lgr:
				item = xbmcgui.ListItem(lcl(str(i)))
				list2.addItem(item)
		list2.selectItem(self.clp)
		
		
		#if len(L)>0: self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
		#else:self.setFocus(self.getControl(800))
		if len(L)>0:     self.setFocus(self.getControl(600))
		elif len(Lgr)>0: self.setFocus(self.getControl(800))
		else:            self.setFocus(self.getControl(5))
		
		xbmc.sleep(10)
		#print '== showList 6'
		if len(L)>0: self.updateEPG()
		#print '== showList end'
	
	def setPlayed(self):
			if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
			else: last_id ='0'
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					if last_id == item.getProperty('id'): item.setLabel2(item.getLabel())
					else: item.setLabel2('')
				except:
					pass
	
	def setArhive2(self):
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(0, n):
				item = list1.getListItem(i)
				id = item.getProperty('id')
				if id in Arhive.keys(): 
					arh=id
				#	arh=Arhive[id]
				else:
					arh=""
				item.setProperty('arhive', arh)
				if arh == '': item.setProperty('arhive_visible', 'false')
				else:        item.setProperty('arhive_visible', 'true')

	def setArhive(self):
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			AK=Arhive.keys()
			
			for i in range(n):
				item = list1.getListItem(i)
				id = item.getProperty('id')
				if id in AK: 
					item.setProperty('arhive', id)
					item.setProperty('arhive_visible', 'true')


	def updateEPG(self):
		list1=self.getControl(600)
		if __settings__.getSetting("epgon")=='true' and list1.size()>0:
			for i in range(0, list1.size()):
				try:
					item = list1.getListItem(i)
					self.set_epg(item)
				except: pass
			
			update_current_epg()
			
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					self.set_epg(item)
				except: 
					#self.close()
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
		else:
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					#item.setProperty('EPG0_title', item.getLabel())
					item.setProperty('EPG0_img',background)#item.getProperty('picon')
				except: 
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
	
	def run_editor(self):
				#skin = "Default"
				editor = EDITOR_XML("PTV-EDITOR.xml", addon.getAddonInfo('path'), skin, "720p")
				editor.doModal()
				del editor

	def run_arhive(self):
				#skin = "Default"
				arhive = ARHIVE_XML("PTV-arhive.xml", addon.getAddonInfo('path'), skin, "720p")
				arhive.doModal()
				del arhive
	def run_picon(self):
				#skin = "Default"
				picon = PICON_XML("PTV-picon.xml", addon.getAddonInfo('path'), skin, "720p")
				picon.doModal()
				del picon


class EDITOR_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		pass
	
	def onInit(self):
		self.showList()
		self.setFocus(self.getControl(500))


	def showList(self):
		#Группы
		
		SG=pztv.get_SG()
		list1=self.getControl(500)
		list1.reset()
		Lgr=pztv.select_gr('', True)
		for i in Lgr:
				item = xbmcgui.ListItem(str(i))
				if SG==str(i): item.setLabel2(str(i))
				else:item.setLabel2('')
				list1.addItem(item)

		# Все каналы
		CL=pztv.get_gr()
		list2=self.getControl(600)
		list2.reset()
		if pztv.get_autoexit_gr(): pas=False
		else: pas=True
		Lcn=pztv.get_gr('Все каналы', pas)
		for i in Lcn:
				title=pztv.DBC[i]['title']
				item = xbmcgui.ListItem(title)
				if i in CL: item.setLabel2(title)
				else:item.setLabel2('')
				item.setProperty('id', i)
				list2.addItem(item)

		list3=self.getControl(700)
		list3.reset()
		Lcn=pztv.get_gr()
		for i in Lcn:
			
				try:title=pztv.DBC[i]['title']
				except: title=i
				item = xbmcgui.ListItem(title)
				item.setProperty('id', i)
				list3.addItem(item)


	def color500(self):
		SG=pztv.get_SG()
		list1=self.getControl(500)
		Lgr=pztv.select_gr('', True)
		n=0
		for i in Lgr:
				item=list1.getListItem(n)
				if SG==str(i): item.setLabel2(str(i))
				else:item.setLabel2('')
				n+=1

	def color600(self):
		CL=pztv.get_gr()
		list2=self.getControl(600)
		if pztv.get_autoexit_gr(): pas=False
		else: pas=True
		Lcn=pztv.get_gr('Все каналы', pas)
		n=0
		for i in Lcn:
				title=pztv.DBC[i]['title']
				item=list2.getListItem(n)
				if i in CL: item.setLabel2(title)
				else:item.setLabel2('')
				n+=1

	def reset600(self):
		CL=pztv.get_gr()
		list2=self.getControl(600)
		list2.reset()
		if pztv.get_autoexit_gr(): pas=False
		else: pas=True
		Lcn=pztv.get_gr('Все каналы', pas)
		for i in Lcn:
				title=pztv.DBC[i]['title']
				item = xbmcgui.ListItem(title)
				if i in CL: item.setLabel2(title)
				else:item.setLabel2('')
				item.setProperty('id', i)
				list2.addItem(item)



	def reset700(self):
		list3=self.getControl(700)
		list3.reset()
		Lcn=pztv.get_gr()
		for i in Lcn:
				try:title=pztv.DBC[i]['title']
				except: title=i
				item = xbmcgui.ListItem(title)
				item.setProperty('id', i)
				list3.addItem(item)


	def onClick(self, controlID):
		#print 'onClick ' +str(controlID)
				
		if controlID == 500:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			SG=listitem.getLabel()
			if 'COLOR' in SG: SG=pztv.get_access_gr(SG)
			if 'COLOR' not in SG:
				__settings__.setSetting("Sel_gr",SG)
			self.color500()
			self.reset600()
			self.reset700()
		
		if controlID == 600:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			id=listitem.getProperty('id')
			if listitem.getLabel2()=='': pztv.add_to_gr(id, pztv.get_SG())
			else: pztv.rem_from_gr(id)
			self.color500()
			self.color600()
			self.reset700()
		
		if controlID == 700:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			id=listitem.getProperty('id')
			pztv.rem_from_gr(id)
			list.removeItem(list.getSelectedPosition())
			self.color600()

		if controlID == 5:
			__settings__.openSettings()
			self.showList()
			

class ARHIVE_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		self.dir=__settings__.getSetting("arhive_cnl")
		self.cid=__settings__.getSetting("arhive_cnl_id")
		try: self.epg=eval(pztv.getURL('http://127.0.0.1:'+epg_port+'/channel/full/id='+str(self.cid)))
		except: self.epg={}
		pztv.set_arhive_date(0)
	
	def onInit(self):
		global UPD
		UPD = True
		self.showList()
		self.setFocus(self.getControl(600))
	
	def showList(self):
		win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
		picon = pztv.get_picon(self.cid)
		ctitle = pztv.DBC[self.cid]['title']
		arhive_date = pztv.get_arhive_date()
		win.setProperty('update', 'update.gif')
		win.setProperty('picon',  picon)
		win.setProperty('picon_background', os.path.join(addon.getAddonInfo('path'), 'background.png'))
		win.setProperty('title',  ctitle)
		win.setProperty('date',  arhive_date)
		#даты
		list1=self.getControl(500)
		list1.reset()
		for i in range (0,7):
			ssec=i*24*60*60
			t=time.localtime(time.time() - ssec)
			st=time.strftime('%d.%m.%Y',t)
			item = xbmcgui.ListItem(st)
			if st == arhive_date: item.setLabel2(st)
			list1.addItem(item)
		
		# передачи
		list2=self.getControl(600)
		list2.reset()
		L=pztv.get_arhive_canale(self.dir)
		for i in L:
			title = i['tms']+' - '+i['title']
			item = xbmcgui.ListItem(title)
			item.setProperty('curl', i['stream'])#D[title]
			list2.addItem(item)
		
		if L!=[]: self.setFocus(self.getControl(600))
		else: self.setFocus(self.getControl(500))
		win.setProperty('update', '')

	def onClick(self, controlID):
		#print 'onClick ' +str(controlID)
		
		if controlID == 600:
			
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			curl=listitem.getProperty('curl')
			title = listitem.getLabel()
			picon = pztv.get_picon(self.cid)
			ct = int(curl[curl.rfind('=')+1:])
			rp = curl[:curl.rfind('=')+1]
			
			
			playlist = xbmc.PlayList (xbmc.PLAYLIST_VIDEO)
			playlist.clear()
			
			for i in range(200):
				n_curl = rp+str(ct+i*60)
				item = xbmcgui.ListItem(title, path=n_curl)
				playlist.add(url=n_curl, listitem=item)
			
			player=xbmc.Player()
			__settings__.setSetting("cplayed",'arh')
			player.play(playlist)
			
			for j in range(100):
				if not xbmc.Player().isPlaying(): time.sleep(10)
			
			print ('start monitor')
			for n in range(200):
				if xbmc.Player().isPlaying():
					for t in range(60):
						if xbmc.Player().isPlaying(): time.sleep(1)
						else: break
					lp = playlist.getposition()
					n_curl = rp+str(ct+(n+lp)*60)
					#print (n_curl)
					playlist.remove(n_curl)
			print ('stop monitor')
			
		if controlID == 500:
			list=self.getControl(controlID)
			r=list.getSelectedPosition()
			pztv.set_arhive_date(r)
			self.showList()

class PICON_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		self.cid=__settings__.getSetting("picon_id")
		self.cnl=__settings__.getSetting("picon_cnl")
	
	def onInit(self):
		self.showList()
		self.setFocus(self.getControl(600))
	
	def showList(self):
		
		win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
		#picon = pztv.get_picon(self.cid)
		title = self.cnl
		win.setProperty('title',  title)
		# передачи
		L=pztv.get_picons(title)
		list1=self.getControl(600)
		list1.reset()
		for i in L:
				#print i
				title=i[i.rfind('/')+1:]
				item = xbmcgui.ListItem(title)
				item.setProperty('id', self.cid)
				item.setProperty('picon', i)
				list1.addItem(item)

	def onClick(self, controlID):
		#print 'onClick ' +str(controlID)
		
		if controlID == 600:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			id=listitem.getProperty('id')
			cp=os.path.join(pztv.Logo, id+'.png')
			cover=listitem.getProperty('picon')
			try:
				import urllib2
				req = urllib2.Request(url = cover, data = None)
				req.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) ; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; .NET4.0C)')
				resp = urllib2.urlopen(req)
				fl = open(cp, "wb")
				fl.write(resp.read())
				fl.close()
			except: pass
			self.close()



def main():
	passw = __settings__.getSetting("passw")
	if passw == '': 
		xbmc.executebuiltin("Addon.OpenSettings(plugin.video.pazl.lt)")
	else:
		#skin = "Default"
		ui = UI_XML("PTV-main.xml", addon.getAddonInfo('path'), skin, "720p")
		ui.doModal()
		del ui

Ls=["Default", "Estuary", "Glass", "Grid", "Table", "Guide", "Aeon", "Metropolis"]
skin = Ls[int(__settings__.getSetting('skin'))]

#xbmcplugin.endOfDirectory(handle, False, False)

main()
